<?php

class Push_Model_Db_Table_Android_Device extends Core_Model_Db_Table {

    protected $_name = "push_gcm_devices";
    protected $_primary = "device_id";

    public function findByAppId($app_id) {

        $select = $this->select()
            ->from(array('pgd' => $this->_name))
//            ->joinLeft(array('_table_is_read' => 'push_delivered_message'), '_table_is_read.device_id = pgd.device_id AND _table_is_read.status = 1 AND _table_is_read.is_read = 0', array('not_read' => new Zend_Db_Expr('COUNT(_table_is_read.deliver_id)')))
//            ->joinLeft(array('pdm' => 'push_delivered_message'), 'pdm.device_id = pgd.device_id', array())
            ->where('pgd.app_id = ?', $app_id)
            ->where('pgd.status = ?', 'active')
            ->group('pgd.device_id')
            ->setIntegrityCheck(false)
        ;
        return $this->fetchAll($select);
    }

    public function findNotReceivedMessages($device_uid, $geolocated) {

        $created_at = $this->_db->fetchOne($this->_db->select()->from('push_gcm_devices', array('created_at'))->where('registration_id = ?', $device_uid));

        $join = join(' AND ', array(
            'pdm.message_id = pm.message_id',
            $this->_db->quoteInto('pdm.device_uid = ?', $device_uid)
        ));

        $select = $this->_db->select()
            ->from(array('pm' => 'push_messages'), array('pm.message_id'))
            ->joinLeft(array('pdm' => 'push_delivered_message'), $join, array())
            ->where('pm.created_at >= ?', $created_at)
//            ->where('pdm.message_id IS NULL')
            ->where('pdm.is_displayed = ?', '0')
            ->where('pm.status = ?', 'delivered')
        ;

        if($geolocated === true) $select->where('pm.latitude IS NOT NULL')->where('pm.longitude IS NOT NULL')->where('pm.radius IS NOT NULL');
        else if($geolocated === false) $select->where('pm.latitude IS NULL')->where('pm.longitude IS NULL')->where('pm.radius IS NULL');

        return $this->_db->fetchCol($select);

    }

    public function countUnreadMessages($device_uid) {

        $device_type = Push_Model_Iphone_Device::DEVICE_TYPE;

        $select = $this->_db->select()
            ->from(array('pm' => 'push_messages'), array('not_read' => new Zend_Db_Expr('COUNT(pdm.deliver_id)')))
            ->join(array('pdm' => 'push_delivered_message'), 'pdm.message_id = pm.message_id AND pdm.is_read = 0', array())
            ->where('pdm.device_uid = ?', $device_uid)
            ->where('pdm.is_displayed = ?', '1')
            ->group('pdm.device_uid')
        ;

        return $this->_db->fetchOne($select);
    }

}

